//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGAdvancedEdgesPS.cpp
// Description : Classe pour le Pixel Shader de l'effet des bords avance.
//===========================================================================


#include "./CGAdvancedEdgesPS.h"


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGAdvancedEdgesPS::enable( void )
{
   // activation du profil
   CCGPixelShader::enable() ;

   // activation de la texture
   cgGLEnableTextureParameter( m_cgpEdgeTex ) ;

   // on dit a OpenGL qu'il faut utiliser ce programme
   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGAdvancedEdgesPS::disable( void )
{
   // desactivation de la texture
   cgGLDisableTextureParameter( m_cgpEdgeTex ) ;

   // desactivation du profil (qui desactive tout le reste)
   CCGPixelShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGAdvancedEdgesPS::setEdgeTexParamName( const char * name )
{
   m_cgpEdgeTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGAdvancedEdgesPS::setConstColorParamName( const char * name )
{
   m_cgpConstColor = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGAdvancedEdgesPS::setCU_EdgeTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpEdgeTex, texname ) ;
}

//-------------------------------------------------------------------------

void CCGAdvancedEdgesPS::setCU_ConstColor( const GLfloat * color )
{
   cgGLSetParameter3fv( m_cgpConstColor, color ) ;
}

//-------------------------------------------------------------------------
