//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGAdvancedEdgesPS.h
// Description : Classe pour le Pixel Shader de l'effet des bords avance.
//===========================================================================


#ifndef __CGADVANCEDEDGESPS_H
#define __CGADVANCEDEDGESPS_H

#include "./CGPixelShader.h"


//-------------------------------------------------------------------------
class CCGAdvancedEdgesPS : public CCGPixelShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGAdvancedEdgesPS( CGcontext context, const char * file, const char * entry )
      : CCGPixelShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setEdgeTexParamName(    const char * name ) ;
   void setConstColorParamName( const char * name ) ;

   // parametres uniformes constants
   void setCU_EdgeTex(          GLuint    texname ) ;
   void setCU_ConstColor( const GLfloat * color   ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpEdgeTex    ;
   CGparameter m_cgpConstColor ;

} ;
//-------------------------------------------------------------------------

#endif //__CGADVANCEDEDGESPS_H
