//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGAdvancedEdgesVS.cpp
// Description : Classe pour le Vertex Shader de l'effet des bords avance.
//===========================================================================


#include "./CGAdvancedEdgesVS.h"
#include <stdio.h>


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGAdvancedEdgesVS::enable(  void )
{
   // activation du profil courant
   CCGVertexShader::enable() ;

   // on change la position de la camera
   cgGLSetParameter3fv( m_cgpEyePosition, m_pEyePosition->position() ) ;

   // on donne la matrice de projection et de vue actuelle
   cgGLSetStateMatrixParameter( m_cgpModelViewProjMatrix, CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY ) ;

   // on dit a OpenGL qu'il faut utiliser ce programme
   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGAdvancedEdgesVS::disable( void )
{
   // desactivation du profil (qui desactive tout le reste)
   CCGVertexShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGAdvancedEdgesVS::setModelViewProjMatrixParamName( const char * name )
{
   m_cgpModelViewProjMatrix = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGAdvancedEdgesVS::setEyePositionParamName( const char * name )
{
   m_cgpEyePosition = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGAdvancedEdgesVS::setU_EyePosition( const qglviewer::Camera * cam )
{
   m_pEyePosition = cam ;
}

//-------------------------------------------------------------------------
