//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGAdvancedEdgesVS.h
// Description : Classe pour le Vertex Shader de l'effet des bords avance.
//===========================================================================


#ifndef __CGADVANCEDEDGESVS_H
#define __CGADVANCEDEDGESVS_H

#include <QGLViewer/qglviewer.h>
#include "./CGVertexShader.h"


//-------------------------------------------------------------------------
class CCGAdvancedEdgesVS : public CCGVertexShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGAdvancedEdgesVS( CGcontext context, const char * file, const char * entry )
      : CCGVertexShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setModelViewProjMatrixParamName( const char * name ) ;
   void setEyePositionParamName(         const char * name ) ;

   // parametres uniformes
   void setU_EyePosition( const qglviewer::Camera * cam ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpModelViewProjMatrix ;

   CGparameter m_cgpEyePosition ;
   const qglviewer::Camera * m_pEyePosition ;

} ;
//-------------------------------------------------------------------------

#endif //__CGADVANCEDEDGESVS_H
