//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGPixelShader.h
// Description : Classe permettant de stocker les informations necessaires
//               a un Pixel Shader ecrit en CG.
//===========================================================================


#ifndef __CGPIXELSHADER_H
#define __CGPIXELSHADER_H

#include "./CGShader.h"


//-------------------------------------------------------------------------
class CCGPixelShader : public CCGShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEUR
   // si <entry>         == 0 alors on utilise "main" comme point d'entree
   // si <profile>       == 0 alors on utilise le  meilleur   profil
   // si <compiler_args> == 0 alors on utilise les meilleures options
   CCGPixelShader(       CGcontext    context                     ,
                   const char      *  file                        ,
                   const char      *  entry         = 0           ,
                         CGenum       type          = CG_SOURCE   ,
                         CGprofile    profile       = (CGprofile)0,
                   const char      ** compiler_args = 0            ) ;
   //----------------------------------------------------------------

} ;
//-------------------------------------------------------------------------

#endif //__CGPIXELSHADER_H
