//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGShader.h
// Description : Classe permettant de stocker les informations necessaires
//               a un Shader ecrit en CG.
//===========================================================================


#ifndef __CGSHADER_H
#define __CGSHADER_H

#include <Cg/cg.h>
#include <Cg/cgGL.h>


//-------------------------------------------------------------------------
class CCGShader
{

public :
   
   //----------------------------------------------------------------
   // CONSRUCTEURS - DESTRUCTEUR
   // si <entry>         == 0 alors on utilise "main" comme point d'entree
   // si <profile>       == 0 alors on utilise le  meilleur   profil
   // si <compiler_args> == 0 alors on utilise les meilleures options
   CCGShader(       CGcontext    context                     ,
              const char      *  file                        ,
              const char      *  entry         = 0           ,
                    CGenum       type          = CG_SOURCE   ,
                    CGprofile    profile       = (CGprofile)0,
              const char      ** compiler_args = 0            ) ;

   virtual ~CCGShader( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // ACCESSEURS
   virtual CGprogram getProgram( void ) const { return m_cgpProgram ; }
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   virtual void enable(  void ) ;
   virtual void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // MODIFIEURS
   virtual void recompile( void ) ;
   //----------------------------------------------------------------

protected :

   // constructeur par defaut pour les classes filles
   CCGShader( void ) {}

   CGprogram m_cgpProgram ;
   CGprofile m_cgpProfile ;

} ;
//-------------------------------------------------------------------------

#endif //__CGSHADER_H
