//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGBasicEdgesPS.cpp
// Description : Classe pour le Pixel Shader de l'effet des bords en
//               Toon Shading.
//===========================================================================


#include "./CGBasicEdgesPS.h"


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGBasicEdgesPS::enable( void )
{
   // activation du profil
   CCGPixelShader::enable() ;

   // activation de la texture
   cgGLEnableTextureParameter( m_cgpEdgeTex ) ;

   // on dit a OpenGL qu'il faut utiliser ce programme
   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesPS::disable( void )
{
   // desactivation de la texture
   cgGLDisableTextureParameter( m_cgpEdgeTex ) ;

   // desactivation du profil (qui desactive tout le reste)
   CCGPixelShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGBasicEdgesPS::setEdgeTexParamName( const char * name )
{
   m_cgpEdgeTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesPS::setCU_EdgeTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpEdgeTex, texname ) ;
}

//-------------------------------------------------------------------------
