//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGBasicEdgesPS.h
// Description : Classe pour le Pixel Shader de l'effet des bords en
//               Toon Shading.
//===========================================================================


#ifndef __CGBASICEDGESPS_H
#define __CGBASICEDGESPS_H

#include "./CGPixelShader.h"


//-------------------------------------------------------------------------
class CCGBasicEdgesPS : public CCGPixelShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGBasicEdgesPS( CGcontext context, const char * file, const char * entry )
      : CCGPixelShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setEdgeTexParamName( const char * name ) ;

   // parametres uniformes constants
   void setCU_EdgeTex( GLuint texname ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpEdgeTex ;

} ;
//-------------------------------------------------------------------------

#endif //__CGBASICEDGESPS_H
