//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGBasicEdgesVS.h
// Description : Classe pour le Vertex Shader de l'effet des bords en
//               Toon Shading.
//===========================================================================


#include "./CGBasicEdgesVS.h"
#include <stdio.h>


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGBasicEdgesVS::enable(  void )
{
   // activation du profil courant
   CCGVertexShader::enable() ;

   // on change la position de la camera
   cgGLSetParameter3fv( m_cgpEyePosition, m_pEyePosition->position() ) ;

   // on donne la matrice de projection et de vue actuelle
   cgGLSetStateMatrixParameter( m_cgpModelViewProjMatrix, CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY ) ;

   // on dit a OpenGL qu'il faut utiliser ce programme
   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesVS::disable( void )
{
   // desactivation du profil (qui desactive tout le reste)
   CCGVertexShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGBasicEdgesVS::setModelViewProjMatrixParamName( const char * name )
{
   m_cgpModelViewProjMatrix = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesVS::setEyePositionParamName( const char * name )
{
   m_cgpEyePosition = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesVS::setU_EyePosition( const qglviewer::Camera * cam )
{
   m_pEyePosition = cam ;
}

//-------------------------------------------------------------------------
