//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGBasicEdgesVS.h
// Description : Classe pour le Vertex Shader de l'effet des bords en
//               Toon Shading.
//===========================================================================


#ifndef __CGBASICEDGESVS_H
#define __CGBASICEDGESVS_H

#include <QGLViewer/qglviewer.h>
#include "./CGVertexShader.h"


//-------------------------------------------------------------------------
class CCGBasicEdgesVS : public CCGVertexShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGBasicEdgesVS( CGcontext context, const char * file, const char * entry )
      : CCGVertexShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setModelViewProjMatrixParamName( const char * name ) ;
   void setEyePositionParamName(         const char * name ) ;

   // parametres uniformes constants
   //void setCU_EyePosition( float x, float y, float z ) ;

   // parametres uniformes
   void setU_EyePosition( const qglviewer::Camera * cam ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpModelViewProjMatrix ;

   CGparameter m_cgpEyePosition ;
   const qglviewer::Camera * m_pEyePosition ;

} ;
//-------------------------------------------------------------------------

#endif //__CGBASICEDGESVS_H
