//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGVertexShader.h
// Description : Classe permettant de stocker les informations necessaires
//               a un Vertex Shader ecrit en CG.
//===========================================================================


#ifndef __CGVERTEXSHADER_H
#define __CGVERTEXSHADER_H

#include "./CGShader.h"


//-------------------------------------------------------------------------
class CCGVertexShader : public CCGShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEUR
   // si <entry>         == 0 alors on utilise "main" comme point d'entree
   // si <profile>       == 0 alors on utilise le  meilleur   profil
   // si <compiler_args> == 0 alors on utilise les meilleures options
   CCGVertexShader(       CGcontext    context                     ,
                    const char      *  file                        ,
                    const char      *  entry         = 0           ,
                          CGenum       type          = CG_SOURCE   ,
                          CGprofile    profile       = (CGprofile)0,
                    const char      ** compiler_args = 0            ) ;
   //----------------------------------------------------------------

} ;
//-------------------------------------------------------------------------

#endif //__CGVERTEXSHADER_H
