//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : GLWindow.h
// Description : Classe contenant les informations d'une fenetre
//===========================================================================


#ifndef __GLWINDOW_H
#define __GLWINDOW_H

#include <X3DTK/simplex3dglscene.h>
#include <X3DTK/simplifiedmeshscene.h>
#include <X3DTK/MESH/facesdrawer.h>
#include <QGLViewer/qglviewer.h>
#include "./CGEffect.h"
#include "./GLTexture.h"
#include "./CGShaderManager.h"
#include "./CGBasicEdgesVS.h"
#include "./CGBasicEdgesPS.h"


//-------------------------------------------------------------------------
class CGLWindow : public QGLViewer
{

public :

   //-----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEUR
   CGLWindow( void ) ;
   virtual ~CGLWindow( void ) ;
   //-----------------------------------------------------------------
   
protected :
      
   //-----------------------------------------------------------------
   // ACTIONS
   virtual void draw( void ) ;
   virtual void init( void ) ;

   virtual void keyPressEvent( QKeyEvent * e ) ;

   virtual void help( void ) const ;
   //-----------------------------------------------------------------

   //-----------------------------------------------------------------
   // PARAMETRAGE
   virtual void loadSceneFile( void ) ;
   virtual void loadEdgeFile( void ) ;
   //-----------------------------------------------------------------

   //-----------------------------------------------------------------
   // ACCESSEURS
   virtual QString helpString( void ) const ;
   //-----------------------------------------------------------------


   CCGShaderManager * m_pShaderManager ;
   CCGBasicEdgesVS  * m_pBasicEdgesVS  ;
   CCGBasicEdgesPS  * m_pBasicEdgesPS  ;

   CCGEffect * m_pEffect ;
   
   CGLTexture * m_pEdgeGLTex ;

   X3DTK::SimplifiedMeshScene m_oMeshScene ; // la scene
   X3DTK::MESH::FacesDrawer   m_oDrawer    ; // l'afficheur de scene

} ;
//-------------------------------------------------------------------------

#endif //__GLWINDOW_H
