//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGBasicEdgesStylisedPS.cpp
// Description : Classe pour le Pixel Shader de l'effet des bords avec style
//               de dessin.
//===========================================================================


#include "./CGBasicEdgesStylisedPS.h"


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::enable( void )
{
   // activation du profil
   CCGPixelShader::enable() ;

   // activation des textures
   cgGLEnableTextureParameter( m_cgpEdgeTex  ) ;
   cgGLEnableTextureParameter( m_cgpStyleTex ) ;

   // on dit a OpenGL qu'il faut utiliser ce programme
   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::disable( void )
{
   // desactivation des textures
   cgGLDisableTextureParameter( m_cgpStyleTex ) ;
   cgGLDisableTextureParameter( m_cgpEdgeTex  ) ;

   // desactivation du profil (qui desactive tout le reste)
   CCGPixelShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::setEdgeTexParamName( const char * name )
{
   m_cgpEdgeTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::setStyleTexParamName( const char * name )
{
   m_cgpStyleTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::setConstColorParamName( const char * name )
{
   m_cgpConstColor = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::setCU_EdgeTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpEdgeTex, texname ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::setCU_StyleTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpStyleTex, texname ) ;
}

//-------------------------------------------------------------------------

void CCGBasicEdgesStylisedPS::setCU_ConstColor( GLfloat * color )
{
   cgGLSetParameter3fv( m_cgpConstColor, color ) ;
}

//-------------------------------------------------------------------------
