//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGBasicEdgesStylisedPS.h
// Description : Classe pour le Pixel Shader de l'effet des bords avec style
//               de dessin.
//===========================================================================


#ifndef __CGBASICEDGESSTYLISEDPS_H
#define __CGBASICEDGESSTYLISEDPS_H

#include "./CGPixelShader.h"


//-------------------------------------------------------------------------
class CCGBasicEdgesStylisedPS : public CCGPixelShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGBasicEdgesStylisedPS( CGcontext context, const char * file, const char * entry )
      : CCGPixelShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setEdgeTexParamName(    const char * name ) ;
   void setStyleTexParamName(   const char * name ) ;
   void setConstColorParamName( const char * name ) ;

   // parametres uniformes constants
   void setCU_EdgeTex(    GLuint    texname ) ;
   void setCU_StyleTex(   GLuint    texname ) ;
   void setCU_ConstColor( GLfloat * color   ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpEdgeTex    ;
   CGparameter m_cgpStyleTex   ;
   CGparameter m_cgpConstColor ;

} ;
//-------------------------------------------------------------------------

#endif //__CGBASICEDGESSTYLISEDPS_H
