//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGBasicEdgesStylisedVS.h
// Description : Classe pour le Vertex Shader de l'effet des bords avec style
//               de dessin.
//===========================================================================


#ifndef __CGBASICEDGESSTYLISEDVS_H
#define __CGBASICEDGESSTYLISEDVS_H

#include <QGLViewer/qglviewer.h>
#include "./CGVertexShader.h"


//-------------------------------------------------------------------------
class CCGBasicEdgesStylisedVS : public CCGVertexShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGBasicEdgesStylisedVS( CGcontext context, const char * file, const char * entry )
      : CCGVertexShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setModelViewProjMatrixParamName( const char * name ) ;
   void setEyePositionParamName(         const char * name ) ;

   // parametres uniformes
   void setU_EyePosition( const qglviewer::Camera * cam ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpModelViewProjMatrix ;

   CGparameter m_cgpEyePosition ;
   const qglviewer::Camera * m_pEyePosition ;

} ;
//-------------------------------------------------------------------------

#endif //__CGBASICEDGESSTYLISEDVS_H
