//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGSketchPS.cpp
// Description : Classe pour le Pixel Shader de l'effet de dessin.
//===========================================================================


#include "./CGSketchPS.h"


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGSketchPS::enable( void )
{
   // activation du profil
   CCGPixelShader::enable() ;

   // activation de la texture
   cgGLEnableTextureParameter( m_cgpBrushTex ) ;

   // on dit a OpenGL qu'il faut utiliser ce programme
   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGSketchPS::disable( void )
{
   // desactivation de la texture
   cgGLDisableTextureParameter( m_cgpBrushTex ) ;

   // desactivation du profil (qui desactive tout le reste)
   CCGPixelShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGSketchPS::setBrushTexParamName( const char * name )
{
   m_cgpBrushTex = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGSketchPS::setConstColorParamName( const char * name )
{
   m_cgpConstColor = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGSketchPS::setCU_BrushTex( GLuint texname )
{
   cgGLSetTextureParameter( m_cgpBrushTex, texname ) ;
}

//-------------------------------------------------------------------------

void CCGSketchPS::setCU_ConstColor( float * color )
{
   cgGLSetParameter3fv( m_cgpConstColor, color ) ;
}

//-------------------------------------------------------------------------
