//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGSketchPS.h
// Description : Classe pour le Pixel Shader de l'effet de dessin.
//===========================================================================


#ifndef __CGSKETCHPS_H
#define __CGSKETCHPS_H

#include "./CGPixelShader.h"


//-------------------------------------------------------------------------
class CCGSketchPS : public CCGPixelShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGSketchPS( CGcontext context, const char * file, const char * entry )
      : CCGPixelShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setBrushTexParamName(   const char * name ) ;
   void setConstColorParamName( const char * name ) ;

   // parametres uniformes constants
   void setCU_BrushTex( GLuint texname ) ;
   void setCU_ConstColor( float * color ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpBrushTex   ;
   CGparameter m_cgpConstColor ;

} ;
//-------------------------------------------------------------------------

#endif //__CGSKETCHPS_H
