//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGSketchVS.cpp
// Description : Classe pour le Vertex Shader de l'effet de dessin.
//===========================================================================


#include "./CGSketchVS.h"
#include <stdio.h>


//-------------------------------------------------------------------------
// INTERFACE UTILISATION --------------------------------------------------
//-------------------------------------------------------------------------

void CCGSketchVS::enable(  void )
{
   // activation du profil courant
   CCGVertexShader::enable() ;

   // on change la position de la camera
   cgGLSetParameter3fv( m_cgpEyePosition, m_pEyePosition->position() ) ;

   // on donne la matrice de projection et de vue actuelle
   cgGLSetStateMatrixParameter( m_cgpModelViewProjMatrix, CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY ) ;

   // on dit a OpenGL qu'il faut utiliser ce programme
   cgGLBindProgram( m_cgpProgram ) ;
}

//-------------------------------------------------------------------------

void CCGSketchVS::disable( void )
{
   // desactivation du profil (qui desactive tout le reste)
   CCGVertexShader::disable() ;
}




//-------------------------------------------------------------------------
// PARAMETRAGE DU SHADER --------------------------------------------------
//-------------------------------------------------------------------------

void CCGSketchVS::setModelViewProjMatrixParamName( const char * name )
{
   m_cgpModelViewProjMatrix = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGSketchVS::setEyePositionParamName( const char * name )
{
   m_cgpEyePosition = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGSketchVS::setDisplacmentParamName( const char * name )
{
   m_cgpDisplacment = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGSketchVS::setFactorParamName( const char * name )
{
   m_cgpFactor = cgGetNamedParameter( m_cgpProgram, name ) ;
}

//-------------------------------------------------------------------------

void CCGSketchVS::setCU_Displacment( float disp )
{
   cgGLSetParameter1f( m_cgpDisplacment, disp ) ;
}

//-------------------------------------------------------------------------

void CCGSketchVS::setCU_Factor( float fact )
{
   cgGLSetParameter1f( m_cgpFactor, fact ) ;
}

//-------------------------------------------------------------------------

void CCGSketchVS::setU_EyePosition( const qglviewer::Camera * cam )
{
   m_pEyePosition = cam ;
}

//-------------------------------------------------------------------------
