//===========================================================================
// Createurs : Clement VIGUIER & Jean-Baptiste SILVY
// Fichier : CGSketchVS.h
// Description : Classe pour le Vertex Shader de l'effet de dessin.
//===========================================================================


#ifndef __CGSKETCHVS_H
#define __CGSKETCHVS_H

#include <QGLViewer/qglviewer.h>
#include "./CGVertexShader.h"


//-------------------------------------------------------------------------
class CCGSketchVS : public CCGVertexShader
{

public :

   //----------------------------------------------------------------
   // CONSTRUCTEURS - DESTRUCTEURS
   CCGSketchVS( CGcontext context, const char * file, const char * entry )
      : CCGVertexShader( context, file, entry ) {}
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // INTERFACE UTILISATION
   void enable(  void ) ;
   void disable( void ) ;
   //----------------------------------------------------------------

   //----------------------------------------------------------------
   // PARAMETRAGE DU SHADER
   void setModelViewProjMatrixParamName( const char * name ) ;
   void setEyePositionParamName(         const char * name ) ;
   void setDisplacmentParamName(         const char * name ) ;
   void setFactorParamName(              const char * name ) ;

   // parametres uniformes constants
   void setCU_Displacment( float disp ) ;
   void setCU_Factor(      float fact ) ;

   // parametres uniformes
   void setU_EyePosition( const qglviewer::Camera * cam ) ;
   //----------------------------------------------------------------

private :

   CGparameter m_cgpModelViewProjMatrix ;
   CGparameter m_cgpDisplacment         ;
   CGparameter m_cgpFactor              ;

   CGparameter m_cgpEyePosition ;
   const qglviewer::Camera * m_pEyePosition ;

} ;
//-------------------------------------------------------------------------

#endif //__CGSKETCHVS_H
